## qtkeychain 0.15.0

=== autotest/CMakeLists.txt ===
include(ECMAddTests)

find_package(Qt${QT_MAJOR_VERSION} COMPONENTS Test REQUIRED)

ecm_add_tests(basic.cpp LINK_LIBRARIES ${QTKEYCHAIN_TARGET_NAME} Qt${QT_MAJOR_VERSION}::Test)
set_property(TARGET basic PROPERTY AUTOMOC ON)

=== qtkeychain/CMakeLists.txt ===

list(APPEND qtkeychain_LIBRARIES ${QTCORE_LIBRARIES})
set(qtkeychain_SOURCES
    keychain.cpp
    qkeychain_export.h
    keychain.h
)

if(MSVC)
    # CMake < 3.15 sneaks in /W# flags for us, so we need a replacement,
    # or we'll get a warning (cf. CMP0092)
    if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()
else()
    # MSVC's STL / Qt headers are not MSVC -Wall clean, so don't enable it there
    add_definitions( -Wall -Werror=return-type )
endif()

if(WIN32)
    list(APPEND qtkeychain_SOURCES keychain_win.cpp)
    list(APPEND qtkeychain_LIBRARIES crypt32)
    if (NOT USE_CREDENTIAL_STORE)
        list(APPEND qtkeychain_SOURCES plaintextstore.cpp)
    endif()
    #FIXME: mingw bug; otherwise getting undefined refs to RtlSecureZeroMemory there
    if(MINGW)
        add_definitions( -O2 )
    endif()

    set(CMAKE_CXX_STANDARD 17)
    add_definitions( /utf-8 -DUNICODE )
endif()

if(APPLE)
    list(APPEND qtkeychain_SOURCES keychain_apple.mm)
    list(APPEND qtkeychain_LIBRARIES "-framework Foundation" "-framework Security")
endif()

if(HAIKU)
    list(APPEND qtkeychain_SOURCES keychain_haiku.cpp)

    find_library(BE_LIBRARY be REQUIRED)
    list(APPEND qtkeychain_LIBRARIES ${BE_LIBRARY})
endif()

if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    option(LIBSECRET_SUPPORT "Build with libsecret support" ON)

    if(LIBSECRET_SUPPORT)
        pkg_check_modules(LIBSECRET REQUIRED libsecret-1)
        add_definitions(-DHAVE_LIBSECRET=1)
        INCLUDE_DIRECTORIES(${LIBSECRET_INCLUDE_DIRS})
        LINK_DIRECTORIES(${LIBSECRET_LIBRARY_DIRS})
        list(APPEND qtkeychain_LIBRARIES_PRIVATE ${LIBSECRET_LIBRARIES})
    endif()

    add_definitions(-DKEYCHAIN_DBUS=1)
    list(APPEND qtkeychain_SOURCES keychain_unix.cpp gnomekeyring.cpp libsecret.cpp plaintextstore.cpp)
    qt_add_dbus_interface(qtkeychain_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/org.kde.KWallet.xml kwallet_interface KWalletInterface)
    list(APPEND qtkeychain_LIBRARIES ${QTDBUS_LIBRARIES} )
endif()

if(ANDROID)
    list(APPEND qtkeychain_SOURCES keychain_android.cpp androidkeystore.cpp plaintextstore.cpp)
    list(APPEND qtkeychain_LIBRARIES_PRIVATE ${QTANDROIDEXTRAS_LIBRARIES} )
endif()

QT_WRAP_CPP(qtkeychain_MOC_OUTFILES keychain.h keychain_p.h gnomekeyring_p.h)

add_library(${QTKEYCHAIN_TARGET_NAME} ${qtkeychain_SOURCES} ${qtkeychain_MOC_OUTFILES} ${qtkeychain_QM_FILES})
if(WIN32)
    set_target_properties( ${QTKEYCHAIN_TARGET_NAME} PROPERTIES DEBUG_POSTFIX "d" )
endif()

target_link_libraries(${QTKEYCHAIN_TARGET_NAME} PUBLIC ${qtkeychain_LIBRARIES} PRIVATE ${qtkeychain_LIBRARIES_PRIVATE})
if(NOT INTERFACE_INCLUDE_SUFFIX)
    set(INTERFACE_INCLUDE_SUFFIX include)
endif()
# Where to find includes when building the library and using it uninstalled: in the parent dir, so that the code has to use <qtkeychain/keychain.h>
target_include_directories(${QTKEYCHAIN_TARGET_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..> $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
# Where to find includes when using the installed qtkeychain
target_include_directories(${QTKEYCHAIN_TARGET_NAME} INTERFACE $<INSTALL_INTERFACE:${INTERFACE_INCLUDE_SUFFIX}>)

generate_export_header(${QTKEYCHAIN_TARGET_NAME}
  EXPORT_FILE_NAME qkeychain_export.h
  EXPORT_MACRO_NAME QKEYCHAIN_EXPORT
)

set_target_properties(${QTKEYCHAIN_TARGET_NAME} PROPERTIES
    VERSION ${QTKEYCHAIN_VERSION}
    SOVERSION ${QTKEYCHAIN_SOVERSION}
    INSTALL_RPATH_USE_LINK_PATH TRUE
)

if (NOT APPLE)
	set_target_properties(${QTKEYCHAIN_TARGET_NAME} PROPERTIES
		INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}"
		)
endif()

install(FILES keychain.h ${CMAKE_CURRENT_BINARY_DIR}/qkeychain_export.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qt${QTKEYCHAIN_VERSION_INFIX}keychain/
)

install(TARGETS ${QTKEYCHAIN_TARGET_NAME}
  EXPORT Qt${QTKEYCHAIN_VERSION_INFIX}KeychainLibraryDepends
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== debian/changelog ===
qtkeychain (0.15.0-2) unstable; urgency=medium

  * Team upload.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Enable the Qt 6 support also on x32.
  * Remove no more used/needed debian/gbp.conf.

 -- Pino Toscano <pino@debian.org>  Thu, 02 Oct 2025 21:29:50 +0200

qtkeychain (0.15.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * The newly added tests require a FreeDesktop Secret service running, so
    disable them for now:
    - pass -DBUILD_TESTING=OFF to cmake
    - override dh_auto_test to be a no-op

 -- Pino Toscano <pino@debian.org>  Tue, 04 Feb 2025 19:54:26 +0100

qtkeychain (0.14.3-3) unstable; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * Remove unused b-d against on libgcrypt20-dev. (Closes: 1071953)

  [ Pino Toscano ]
  * Enable the Qt 6 support also on few more architectures, i.e.
    alpha hppa hurd-amd64 sh4 (everything except m68k and x32).

 -- Pino Toscano <pino@debian.org>  Mon, 25 Nov 2024 16:34:47 +0100

=== debian/control ===
Source: qtkeychain
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libsecret-1-dev,
               pkgconf,
               pkg-kde-tools,
               qt6-base-dev [alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32],
               qt6-l10n-tools [alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32],
               qt6-tools-dev [alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32],
               qt6-tools-dev-tools [alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32],
               qtbase5-private-dev,
               qttools5-dev,
               qttools5-dev-tools,
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/frankosterfeld/qtkeychain
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qtkeychain.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qtkeychain

Package: libqt5keychain1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: gnome-keyring | kwalletmanager
Breaks: libqt5keychain0
Replaces: libqt5keychain0
Description: Qt API to store passwords (Qt 5 version)
 It can use KWallet or GNOME Keyring, if one of them is available.
 If none of them is available, qtkeychain will report an error or writes
 with explicit request the password unencrypted at a file.
 .
 This is the version built for Qt 5.

Package: libqt6keychain1
Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: gnome-keyring | kwalletmanager
Description: Qt API to store passwords (Qt 6 version)
 It can use KWallet or GNOME Keyring, if one of them is available.
 If none of them is available, qtkeychain will report an error or writes
 with explicit request the password unencrypted at a file.
 .
 This is the version built for Qt 6.

Package: qt5keychain-dev
Section: oldlibs
Architecture: any
Depends: qtkeychain-qt5-dev (>= ${binary:Version}), ${misc:Depends}
Description: transitional package for qtkeychain-qt5-dev
 This is a transitional package. It can safely be removed.

Package: qtkeychain-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libqt5keychain1 (= ${binary:Version}), ${misc:Depends}
Provides: qt5keychain-dev
Breaks: qt5keychain-dev (<< 0.13.2-3~)
Replaces: qt5keychain-dev (<< 0.13.2-3~)
Description: development files for qtkeychain (Qt 5 version)
 A Qt API to store passwords.
 .
 It can use KWallet or GNOME Keyring, if one of them is available.
 If none of them is available, qtkeychain will report an error or writes
 with explicit request the password unencrypted at a file.
 .
 This is the version built for Qt 5.

Package: qtkeychain-qt6-dev
Section: libdevel
Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32
Multi-Arch: same
Depends: libqt6keychain1 (= ${binary:Version}), ${misc:Depends}
Description: development files for qtkeychain (Qt 6 version)
 A Qt API to store passwords,
 .
 It can use KWallet or GNOME Keyring, if one of them is available.
 If none of them is available, qtkeychain will report an error or writes
 with explicit request the password unencrypted at a file.
 .
 This is the version built for Qt 6.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

COMMON_CMAKE_ARGS = -DBUILD_TESTING=OFF

%:
	dh $@ --with pkgkde_symbolshelper

ifneq (,$(filter $(DEB_HOST_ARCH), alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 s390x x32))
override_dh_auto_clean:
	dh_auto_clean
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CMAKE_ARGS) -DBUILD_WITH_QT6=OFF
	dh_auto_configure --builddirectory=build-Qt6  -- $(COMMON_CMAKE_ARGS) -DBUILD_WITH_QT6=ON \
		-DECM_MKSPECS_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/qt6/mkspecs/modules

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6
endif

override_dh_auto_test:
	# the tests require a FreeDesktop Secret service running

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/frankosterfeld/qtkeychain/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
